// Package broker provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.15.0 DO NOT EDIT.
package broker

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	bmh "github.com/metal3-io/baremetal-operator/apis/metal3.io/v1alpha1"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/gorilla/mux"
	"github.com/oapi-codegen/runtime"
)

type AuthScope string

const (
	PoolBasicAuthScopes AuthScope = "poolBasicAuth.Scopes"
)

// ChallengeRequest defines model for ChallengeRequest.
type ChallengeRequest struct {
	// Challenge challenge
	Challenge string `json:"challenge"`
}

// ChallengeResponse defines model for ChallengeResponse.
type ChallengeResponse struct {
	// Challenge challenge
	Challenge string `json:"challenge"`

	// SignedChallenge signed challenge
	SignedChallenge *string `json:"signedChallenge,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Message Error message
	Message string `json:"message"`
}

// PasswordData defines model for PasswordData.
type PasswordData struct {
	// Password password
	Password string `json:"password"`
}

// PoolRequest defines model for PoolRequest.
type PoolRequest struct {
	// MaxServers size of the pool
	MaxServers *int `json:"MaxServers,omitempty"`

	// Id Name of the pool
	Id *string `json:"id,omitempty"`

	// LabelSelector labels associated with the pool
	LabelSelector *map[string]string `json:"labelSelector,omitempty"`
}

// PoolResponse defines model for PoolResponse.
type PoolResponse struct {
	// Id name of the pool
	Id *string `json:"id,omitempty"`

	// LabelSelector labels associated with the pool
	LabelSelector *map[string]string `json:"labelSelector,omitempty"`

	// MaxServers size of the pool
	MaxServers *int `json:"maxServers,omitempty"`

	// Username username of the pool
	Username *string `json:"username,omitempty"`
}

// ServerRequest defines model for ServerRequest.
type ServerRequest struct {
	// Id Name of the server
	Id string `json:"id"`

	// Schema schema associated with url of the server
	Schema string `json:"schema"`
}

// ServerResponse defines model for ServerResponse.
type ServerResponse struct {
	// BareMetal name of the bmh associated with the server
	BareMetal *string `json:"bareMetal,omitempty"`

	// DisableCertificateVerification disableCertificateVerification field of the bmh associated with the server
	DisableCertificateVerification *bool `json:"disableCertificateVerification,omitempty"`

	// Id name of the server
	Id string `json:"id"`

	// K8sAnnotations annotations of the bmh associated with the server
	K8sAnnotations *map[string]string `json:"k8sAnnotations,omitempty"`

	// K8sLabels labels of the bmh associated with the server
	K8sLabels *map[string]string `json:"k8sLabels,omitempty"`

	// MacAddress mac address of the bmh associated with the server
	MacAddress *string `json:"macAddress,omitempty"`

	// RootDeviceHints (*bmh.RootDeviceHints) with bmh "github.com/metal3-io/baremetal-operator/apis/metal3.io/v1alpha1"
	RootDeviceHints *bmh.RootDeviceHints `json:"rootDeviceHints,omitempty"`

	// Url url of the bmh associated with the server
	Url *string `json:"url,omitempty"`
}

// SignatureRequest defines model for SignatureRequest.
type SignatureRequest struct {
	// Challenge challenge
	Challenge string `json:"challenge"`

	// Signature signed challenge
	Signature string `json:"signature"`
}

// SignatureResponse defines model for SignatureResponse.
type SignatureResponse struct {
	// SignatureVerified signature verification response
	SignatureVerified string `json:"signatureVerified"`
}

// CreatePoolJSONRequestBody defines body for CreatePool for application/json ContentType.
type CreatePoolJSONRequestBody = PoolRequest

// CreateServerJSONRequestBody defines body for CreateServer for application/json ContentType.
type CreateServerJSONRequestBody = ServerRequest

// SignChallengeJSONRequestBody defines body for SignChallenge for application/json ContentType.
type SignChallengeJSONRequestBody = ChallengeRequest

// TestVerifySignatureJSONRequestBody defines body for TestVerifySignature for application/json ContentType.
type TestVerifySignatureJSONRequestBody = SignatureRequest

// VerifySignatureJSONRequestBody defines body for VerifySignature for application/json ContentType.
type VerifySignatureJSONRequestBody = SignatureRequest

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// Dump request
	Dump(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreatePoolWithBody request with any body
	CreatePoolWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreatePool(ctx context.Context, body CreatePoolJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// RemovePool request
	RemovePool(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetPool request
	GetPool(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetAllServers request
	GetAllServers(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreateServerWithBody request with any body
	CreateServerWithBody(ctx context.Context, poolid string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreateServer(ctx context.Context, poolid string, body CreateServerJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// RemoveServer request
	RemoveServer(ctx context.Context, poolid string, serverid string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetServerByID request
	GetServerByID(ctx context.Context, poolid string, serverid string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// SignChallengeWithBody request with any body
	SignChallengeWithBody(ctx context.Context, poolid string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	SignChallenge(ctx context.Context, poolid string, body SignChallengeJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetPooluserPassword request
	GetPooluserPassword(ctx context.Context, pooluserid string, reqEditors ...RequestEditorFn) (*http.Response, error)

	// TestVerifySignatureWithBody request with any body
	TestVerifySignatureWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	TestVerifySignature(ctx context.Context, body TestVerifySignatureJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// VerifySignatureWithBody request with any body
	VerifySignatureWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	VerifySignature(ctx context.Context, body VerifySignatureJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) Dump(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewDumpRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreatePoolWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreatePoolRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreatePool(ctx context.Context, body CreatePoolJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreatePoolRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) RemovePool(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewRemovePoolRequest(c.Server, poolid)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetPool(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetPoolRequest(c.Server, poolid)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetAllServers(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetAllServersRequest(c.Server, poolid)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateServerWithBody(ctx context.Context, poolid string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateServerRequestWithBody(c.Server, poolid, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateServer(ctx context.Context, poolid string, body CreateServerJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateServerRequest(c.Server, poolid, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) RemoveServer(ctx context.Context, poolid string, serverid string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewRemoveServerRequest(c.Server, poolid, serverid)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetServerByID(ctx context.Context, poolid string, serverid string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetServerByIDRequest(c.Server, poolid, serverid)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) SignChallengeWithBody(ctx context.Context, poolid string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewSignChallengeRequestWithBody(c.Server, poolid, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) SignChallenge(ctx context.Context, poolid string, body SignChallengeJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewSignChallengeRequest(c.Server, poolid, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetPooluserPassword(ctx context.Context, pooluserid string, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetPooluserPasswordRequest(c.Server, pooluserid)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) TestVerifySignatureWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewTestVerifySignatureRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) TestVerifySignature(ctx context.Context, body TestVerifySignatureJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewTestVerifySignatureRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) VerifySignatureWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewVerifySignatureRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) VerifySignature(ctx context.Context, body VerifySignatureJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewVerifySignatureRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewDumpRequest generates requests for Dump
func NewDumpRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/dump")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewCreatePoolRequest calls the generic CreatePool builder with application/json body
func NewCreatePoolRequest(server string, body CreatePoolJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreatePoolRequestWithBody(server, "application/json", bodyReader)
}

// NewCreatePoolRequestWithBody generates requests for CreatePool with any type of body
func NewCreatePoolRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/pools")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewRemovePoolRequest generates requests for RemovePool
func NewRemovePoolRequest(server string, poolid string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "poolid", runtime.ParamLocationPath, poolid)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/pools/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("DELETE", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetPoolRequest generates requests for GetPool
func NewGetPoolRequest(server string, poolid string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "poolid", runtime.ParamLocationPath, poolid)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/pools/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetAllServersRequest generates requests for GetAllServers
func NewGetAllServersRequest(server string, poolid string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "poolid", runtime.ParamLocationPath, poolid)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/pools/%s/servers", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewCreateServerRequest calls the generic CreateServer builder with application/json body
func NewCreateServerRequest(server string, poolid string, body CreateServerJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreateServerRequestWithBody(server, poolid, "application/json", bodyReader)
}

// NewCreateServerRequestWithBody generates requests for CreateServer with any type of body
func NewCreateServerRequestWithBody(server string, poolid string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "poolid", runtime.ParamLocationPath, poolid)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/pools/%s/servers", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewRemoveServerRequest generates requests for RemoveServer
func NewRemoveServerRequest(server string, poolid string, serverid string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "poolid", runtime.ParamLocationPath, poolid)
	if err != nil {
		return nil, err
	}

	var pathParam1 string

	pathParam1, err = runtime.StyleParamWithLocation("simple", false, "serverid", runtime.ParamLocationPath, serverid)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/pools/%s/servers/%s", pathParam0, pathParam1)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("DELETE", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetServerByIDRequest generates requests for GetServerByID
func NewGetServerByIDRequest(server string, poolid string, serverid string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "poolid", runtime.ParamLocationPath, poolid)
	if err != nil {
		return nil, err
	}

	var pathParam1 string

	pathParam1, err = runtime.StyleParamWithLocation("simple", false, "serverid", runtime.ParamLocationPath, serverid)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/pools/%s/servers/%s", pathParam0, pathParam1)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewSignChallengeRequest calls the generic SignChallenge builder with application/json body
func NewSignChallengeRequest(server string, poolid string, body SignChallengeJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewSignChallengeRequestWithBody(server, poolid, "application/json", bodyReader)
}

// NewSignChallengeRequestWithBody generates requests for SignChallenge with any type of body
func NewSignChallengeRequestWithBody(server string, poolid string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "poolid", runtime.ParamLocationPath, poolid)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/pools/%s/signchallenge", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewGetPooluserPasswordRequest generates requests for GetPooluserPassword
func NewGetPooluserPasswordRequest(server string, pooluserid string) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "pooluserid", runtime.ParamLocationPath, pooluserid)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/poolusers/%s/getpassword", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewTestVerifySignatureRequest calls the generic TestVerifySignature builder with application/json body
func NewTestVerifySignatureRequest(server string, body TestVerifySignatureJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewTestVerifySignatureRequestWithBody(server, "application/json", bodyReader)
}

// NewTestVerifySignatureRequestWithBody generates requests for TestVerifySignature with any type of body
func NewTestVerifySignatureRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/redfish-proxy/verifysignature")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewVerifySignatureRequest calls the generic VerifySignature builder with application/json body
func NewVerifySignatureRequest(server string, body VerifySignatureJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewVerifySignatureRequestWithBody(server, "application/json", bodyReader)
}

// NewVerifySignatureRequestWithBody generates requests for VerifySignature with any type of body
func NewVerifySignatureRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/verifysignature")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// DumpWithResponse request
	DumpWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*DumpResponse, error)

	// CreatePoolWithBodyWithResponse request with any body
	CreatePoolWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreatePoolResponse, error)

	CreatePoolWithResponse(ctx context.Context, body CreatePoolJSONRequestBody, reqEditors ...RequestEditorFn) (*CreatePoolResponse, error)

	// RemovePoolWithResponse request
	RemovePoolWithResponse(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*RemovePoolResponse, error)

	// GetPoolWithResponse request
	GetPoolWithResponse(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*GetPoolResponse, error)

	// GetAllServersWithResponse request
	GetAllServersWithResponse(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*GetAllServersResponse, error)

	// CreateServerWithBodyWithResponse request with any body
	CreateServerWithBodyWithResponse(ctx context.Context, poolid string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateServerResponse, error)

	CreateServerWithResponse(ctx context.Context, poolid string, body CreateServerJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateServerResponse, error)

	// RemoveServerWithResponse request
	RemoveServerWithResponse(ctx context.Context, poolid string, serverid string, reqEditors ...RequestEditorFn) (*RemoveServerResponse, error)

	// GetServerByIDWithResponse request
	GetServerByIDWithResponse(ctx context.Context, poolid string, serverid string, reqEditors ...RequestEditorFn) (*GetServerByIDResponse, error)

	// SignChallengeWithBodyWithResponse request with any body
	SignChallengeWithBodyWithResponse(ctx context.Context, poolid string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*SignChallengeResponse, error)

	SignChallengeWithResponse(ctx context.Context, poolid string, body SignChallengeJSONRequestBody, reqEditors ...RequestEditorFn) (*SignChallengeResponse, error)

	// GetPooluserPasswordWithResponse request
	GetPooluserPasswordWithResponse(ctx context.Context, pooluserid string, reqEditors ...RequestEditorFn) (*GetPooluserPasswordResponse, error)

	// TestVerifySignatureWithBodyWithResponse request with any body
	TestVerifySignatureWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*TestVerifySignatureResponse, error)

	TestVerifySignatureWithResponse(ctx context.Context, body TestVerifySignatureJSONRequestBody, reqEditors ...RequestEditorFn) (*TestVerifySignatureResponse, error)

	// VerifySignatureWithBodyWithResponse request with any body
	VerifySignatureWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*VerifySignatureResponse, error)

	VerifySignatureWithResponse(ctx context.Context, body VerifySignatureJSONRequestBody, reqEditors ...RequestEditorFn) (*VerifySignatureResponse, error)
}

type DumpResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r DumpResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r DumpResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreatePoolResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON201      *PoolResponse
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r CreatePoolResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreatePoolResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type RemovePoolResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r RemovePoolResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r RemovePoolResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetPoolResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *PoolResponse
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r GetPoolResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetPoolResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetAllServersResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *[]ServerResponse
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r GetAllServersResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetAllServersResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreateServerResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON201      *ServerResponse
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r CreateServerResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreateServerResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type RemoveServerResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r RemoveServerResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r RemoveServerResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetServerByIDResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ServerResponse
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r GetServerByIDResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetServerByIDResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type SignChallengeResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ChallengeResponse
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r SignChallengeResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r SignChallengeResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetPooluserPasswordResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *PasswordData
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r GetPooluserPasswordResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetPooluserPasswordResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type TestVerifySignatureResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON201      *SignatureResponse
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r TestVerifySignatureResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r TestVerifySignatureResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type VerifySignatureResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON201      *SignatureResponse
	JSONDefault  *Error
}

// Status returns HTTPResponse.Status
func (r VerifySignatureResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r VerifySignatureResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// DumpWithResponse request returning *DumpResponse
func (c *ClientWithResponses) DumpWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*DumpResponse, error) {
	rsp, err := c.Dump(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseDumpResponse(rsp)
}

// CreatePoolWithBodyWithResponse request with arbitrary body returning *CreatePoolResponse
func (c *ClientWithResponses) CreatePoolWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreatePoolResponse, error) {
	rsp, err := c.CreatePoolWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreatePoolResponse(rsp)
}

func (c *ClientWithResponses) CreatePoolWithResponse(ctx context.Context, body CreatePoolJSONRequestBody, reqEditors ...RequestEditorFn) (*CreatePoolResponse, error) {
	rsp, err := c.CreatePool(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreatePoolResponse(rsp)
}

// RemovePoolWithResponse request returning *RemovePoolResponse
func (c *ClientWithResponses) RemovePoolWithResponse(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*RemovePoolResponse, error) {
	rsp, err := c.RemovePool(ctx, poolid, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseRemovePoolResponse(rsp)
}

// GetPoolWithResponse request returning *GetPoolResponse
func (c *ClientWithResponses) GetPoolWithResponse(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*GetPoolResponse, error) {
	rsp, err := c.GetPool(ctx, poolid, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetPoolResponse(rsp)
}

// GetAllServersWithResponse request returning *GetAllServersResponse
func (c *ClientWithResponses) GetAllServersWithResponse(ctx context.Context, poolid string, reqEditors ...RequestEditorFn) (*GetAllServersResponse, error) {
	rsp, err := c.GetAllServers(ctx, poolid, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetAllServersResponse(rsp)
}

// CreateServerWithBodyWithResponse request with arbitrary body returning *CreateServerResponse
func (c *ClientWithResponses) CreateServerWithBodyWithResponse(ctx context.Context, poolid string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateServerResponse, error) {
	rsp, err := c.CreateServerWithBody(ctx, poolid, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateServerResponse(rsp)
}

func (c *ClientWithResponses) CreateServerWithResponse(ctx context.Context, poolid string, body CreateServerJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateServerResponse, error) {
	rsp, err := c.CreateServer(ctx, poolid, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateServerResponse(rsp)
}

// RemoveServerWithResponse request returning *RemoveServerResponse
func (c *ClientWithResponses) RemoveServerWithResponse(ctx context.Context, poolid string, serverid string, reqEditors ...RequestEditorFn) (*RemoveServerResponse, error) {
	rsp, err := c.RemoveServer(ctx, poolid, serverid, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseRemoveServerResponse(rsp)
}

// GetServerByIDWithResponse request returning *GetServerByIDResponse
func (c *ClientWithResponses) GetServerByIDWithResponse(ctx context.Context, poolid string, serverid string, reqEditors ...RequestEditorFn) (*GetServerByIDResponse, error) {
	rsp, err := c.GetServerByID(ctx, poolid, serverid, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetServerByIDResponse(rsp)
}

// SignChallengeWithBodyWithResponse request with arbitrary body returning *SignChallengeResponse
func (c *ClientWithResponses) SignChallengeWithBodyWithResponse(ctx context.Context, poolid string, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*SignChallengeResponse, error) {
	rsp, err := c.SignChallengeWithBody(ctx, poolid, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseSignChallengeResponse(rsp)
}

func (c *ClientWithResponses) SignChallengeWithResponse(ctx context.Context, poolid string, body SignChallengeJSONRequestBody, reqEditors ...RequestEditorFn) (*SignChallengeResponse, error) {
	rsp, err := c.SignChallenge(ctx, poolid, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseSignChallengeResponse(rsp)
}

// GetPooluserPasswordWithResponse request returning *GetPooluserPasswordResponse
func (c *ClientWithResponses) GetPooluserPasswordWithResponse(ctx context.Context, pooluserid string, reqEditors ...RequestEditorFn) (*GetPooluserPasswordResponse, error) {
	rsp, err := c.GetPooluserPassword(ctx, pooluserid, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetPooluserPasswordResponse(rsp)
}

// TestVerifySignatureWithBodyWithResponse request with arbitrary body returning *TestVerifySignatureResponse
func (c *ClientWithResponses) TestVerifySignatureWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*TestVerifySignatureResponse, error) {
	rsp, err := c.TestVerifySignatureWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseTestVerifySignatureResponse(rsp)
}

func (c *ClientWithResponses) TestVerifySignatureWithResponse(ctx context.Context, body TestVerifySignatureJSONRequestBody, reqEditors ...RequestEditorFn) (*TestVerifySignatureResponse, error) {
	rsp, err := c.TestVerifySignature(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseTestVerifySignatureResponse(rsp)
}

// VerifySignatureWithBodyWithResponse request with arbitrary body returning *VerifySignatureResponse
func (c *ClientWithResponses) VerifySignatureWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*VerifySignatureResponse, error) {
	rsp, err := c.VerifySignatureWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseVerifySignatureResponse(rsp)
}

func (c *ClientWithResponses) VerifySignatureWithResponse(ctx context.Context, body VerifySignatureJSONRequestBody, reqEditors ...RequestEditorFn) (*VerifySignatureResponse, error) {
	rsp, err := c.VerifySignature(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseVerifySignatureResponse(rsp)
}

// ParseDumpResponse parses an HTTP response from a DumpWithResponse call
func ParseDumpResponse(rsp *http.Response) (*DumpResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &DumpResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseCreatePoolResponse parses an HTTP response from a CreatePoolWithResponse call
func ParseCreatePoolResponse(rsp *http.Response) (*CreatePoolResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreatePoolResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 201:
		var dest PoolResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON201 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseRemovePoolResponse parses an HTTP response from a RemovePoolWithResponse call
func ParseRemovePoolResponse(rsp *http.Response) (*RemovePoolResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &RemovePoolResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseGetPoolResponse parses an HTTP response from a GetPoolWithResponse call
func ParseGetPoolResponse(rsp *http.Response) (*GetPoolResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetPoolResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest PoolResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseGetAllServersResponse parses an HTTP response from a GetAllServersWithResponse call
func ParseGetAllServersResponse(rsp *http.Response) (*GetAllServersResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetAllServersResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest []ServerResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseCreateServerResponse parses an HTTP response from a CreateServerWithResponse call
func ParseCreateServerResponse(rsp *http.Response) (*CreateServerResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreateServerResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 201:
		var dest ServerResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON201 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseRemoveServerResponse parses an HTTP response from a RemoveServerWithResponse call
func ParseRemoveServerResponse(rsp *http.Response) (*RemoveServerResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &RemoveServerResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseGetServerByIDResponse parses an HTTP response from a GetServerByIDWithResponse call
func ParseGetServerByIDResponse(rsp *http.Response) (*GetServerByIDResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetServerByIDResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ServerResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseSignChallengeResponse parses an HTTP response from a SignChallengeWithResponse call
func ParseSignChallengeResponse(rsp *http.Response) (*SignChallengeResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &SignChallengeResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ChallengeResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseGetPooluserPasswordResponse parses an HTTP response from a GetPooluserPasswordWithResponse call
func ParseGetPooluserPasswordResponse(rsp *http.Response) (*GetPooluserPasswordResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetPooluserPasswordResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest PasswordData
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseTestVerifySignatureResponse parses an HTTP response from a TestVerifySignatureWithResponse call
func ParseTestVerifySignatureResponse(rsp *http.Response) (*TestVerifySignatureResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &TestVerifySignatureResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 201:
		var dest SignatureResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON201 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ParseVerifySignatureResponse parses an HTTP response from a VerifySignatureWithResponse call
func ParseVerifySignatureResponse(rsp *http.Response) (*VerifySignatureResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &VerifySignatureResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 201:
		var dest SignatureResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON201 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && true:
		var dest Error
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSONDefault = &dest

	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Returns broker internal data
	// (GET /redfish-proxy/dump)
	Dump(w http.ResponseWriter, r *http.Request)
	// Creates a new pool
	// (POST /redfish-proxy/pools)
	CreatePool(w http.ResponseWriter, r *http.Request)
	// Deletes a pool by ID
	// (DELETE /redfish-proxy/pools/{poolid})
	RemovePool(w http.ResponseWriter, r *http.Request, poolid string)
	// get a pool
	// (GET /redfish-proxy/pools/{poolid})
	GetPool(w http.ResponseWriter, r *http.Request, poolid string)
	// Returns all servers in the pool
	// (GET /redfish-proxy/pools/{poolid}/servers)
	GetAllServers(w http.ResponseWriter, r *http.Request, poolid string)
	// Creates a new server
	// (POST /redfish-proxy/pools/{poolid}/servers)
	CreateServer(w http.ResponseWriter, r *http.Request, poolid string)
	// Deletes a server by ID
	// (DELETE /redfish-proxy/pools/{poolid}/servers/{serverid})
	RemoveServer(w http.ResponseWriter, r *http.Request, poolid string, serverid string)
	// Returns a server by ID
	// (GET /redfish-proxy/pools/{poolid}/servers/{serverid})
	GetServerByID(w http.ResponseWriter, r *http.Request, poolid string, serverid string)
	// Challenge signature
	// (POST /redfish-proxy/pools/{poolid}/signchallenge)
	SignChallenge(w http.ResponseWriter, r *http.Request, poolid string)
	// get a pool password
	// (GET /redfish-proxy/poolusers/{pooluserid}/getpassword)
	GetPooluserPassword(w http.ResponseWriter, r *http.Request, pooluserid string)
	// Signature verification
	// (POST /redfish-proxy/verifysignature)
	TestVerifySignature(w http.ResponseWriter, r *http.Request)
	// Signature verification
	// (POST /verifysignature)
	VerifySignature(w http.ResponseWriter, r *http.Request)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// Dump operation middleware
func (siw *ServerInterfaceWrapper) Dump(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"infra"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.Dump(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreatePool operation middleware
func (siw *ServerInterfaceWrapper) CreatePool(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"pooluser"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreatePool(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// RemovePool operation middleware
func (siw *ServerInterfaceWrapper) RemovePool(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "poolid" -------------
	var poolid string

	err = runtime.BindStyledParameter("simple", false, "poolid", mux.Vars(r)["poolid"], &poolid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "poolid", Err: err})
		return
	}

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"pool"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.RemovePool(w, r, poolid)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetPool operation middleware
func (siw *ServerInterfaceWrapper) GetPool(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "poolid" -------------
	var poolid string

	err = runtime.BindStyledParameter("simple", false, "poolid", mux.Vars(r)["poolid"], &poolid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "poolid", Err: err})
		return
	}

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"pool"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetPool(w, r, poolid)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetAllServers operation middleware
func (siw *ServerInterfaceWrapper) GetAllServers(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "poolid" -------------
	var poolid string

	err = runtime.BindStyledParameter("simple", false, "poolid", mux.Vars(r)["poolid"], &poolid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "poolid", Err: err})
		return
	}

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"pool"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetAllServers(w, r, poolid)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreateServer operation middleware
func (siw *ServerInterfaceWrapper) CreateServer(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "poolid" -------------
	var poolid string

	err = runtime.BindStyledParameter("simple", false, "poolid", mux.Vars(r)["poolid"], &poolid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "poolid", Err: err})
		return
	}

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"pool"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreateServer(w, r, poolid)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// RemoveServer operation middleware
func (siw *ServerInterfaceWrapper) RemoveServer(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "poolid" -------------
	var poolid string

	err = runtime.BindStyledParameter("simple", false, "poolid", mux.Vars(r)["poolid"], &poolid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "poolid", Err: err})
		return
	}

	// ------------- Path parameter "serverid" -------------
	var serverid string

	err = runtime.BindStyledParameter("simple", false, "serverid", mux.Vars(r)["serverid"], &serverid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "serverid", Err: err})
		return
	}

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"pool"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.RemoveServer(w, r, poolid, serverid)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetServerByID operation middleware
func (siw *ServerInterfaceWrapper) GetServerByID(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "poolid" -------------
	var poolid string

	err = runtime.BindStyledParameter("simple", false, "poolid", mux.Vars(r)["poolid"], &poolid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "poolid", Err: err})
		return
	}

	// ------------- Path parameter "serverid" -------------
	var serverid string

	err = runtime.BindStyledParameter("simple", false, "serverid", mux.Vars(r)["serverid"], &serverid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "serverid", Err: err})
		return
	}

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"pool"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetServerByID(w, r, poolid, serverid)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// SignChallenge operation middleware
func (siw *ServerInterfaceWrapper) SignChallenge(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "poolid" -------------
	var poolid string

	err = runtime.BindStyledParameter("simple", false, "poolid", mux.Vars(r)["poolid"], &poolid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "poolid", Err: err})
		return
	}

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"pool"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.SignChallenge(w, r, poolid)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetPooluserPassword operation middleware
func (siw *ServerInterfaceWrapper) GetPooluserPassword(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "pooluserid" -------------
	var pooluserid string

	err = runtime.BindStyledParameter("simple", false, "pooluserid", mux.Vars(r)["pooluserid"], &pooluserid)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "pooluserid", Err: err})
		return
	}

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"infra"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetPooluserPassword(w, r, pooluserid)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// TestVerifySignature operation middleware
func (siw *ServerInterfaceWrapper) TestVerifySignature(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	ctx = context.WithValue(ctx, PoolBasicAuthScopes, []string{"infra"})

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.TestVerifySignature(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// VerifySignature operation middleware
func (siw *ServerInterfaceWrapper) VerifySignature(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.VerifySignature(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, GorillaServerOptions{})
}

type GorillaServerOptions struct {
	BaseURL          string
	BaseRouter       *mux.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r *mux.Router) http.Handler {
	return HandlerWithOptions(si, GorillaServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r *mux.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, GorillaServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options GorillaServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = mux.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.HandleFunc(options.BaseURL+"/redfish-proxy/dump", wrapper.Dump).Methods("GET")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/pools", wrapper.CreatePool).Methods("POST")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/pools/{poolid}", wrapper.RemovePool).Methods("DELETE")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/pools/{poolid}", wrapper.GetPool).Methods("GET")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/pools/{poolid}/servers", wrapper.GetAllServers).Methods("GET")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/pools/{poolid}/servers", wrapper.CreateServer).Methods("POST")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/pools/{poolid}/servers/{serverid}", wrapper.RemoveServer).Methods("DELETE")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/pools/{poolid}/servers/{serverid}", wrapper.GetServerByID).Methods("GET")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/pools/{poolid}/signchallenge", wrapper.SignChallenge).Methods("POST")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/poolusers/{pooluserid}/getpassword", wrapper.GetPooluserPassword).Methods("GET")

	r.HandleFunc(options.BaseURL+"/redfish-proxy/verifysignature", wrapper.TestVerifySignature).Methods("POST")

	r.HandleFunc(options.BaseURL+"/verifysignature", wrapper.VerifySignature).Methods("POST")

	return r
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xZS3PbthP/Khj8/4ekw4hy00NGNz86qWea1mN1enF8gMgViQQEGAC0o3r03TsA+CZo",
	"SrbT2JqcRBGLff52seDe4UhkueDAtcKLO6yiFDJiH09TwhjwBC7hSwFKm3e5FDlITcFSRBWF+RODiiTN",
	"NRUcL1pLAdabHPACKy0pT/B2G2AJXwoqIcaLqxbl9TZoC1W54AqeSmqAFU04xKfjux0BeojqFfeuMb9K",
	"KeTQgAyUIj4FLD2qlqekV3RG0gVR6lbI+IxoMhSYl6tDifXKlLCa0EoTgo2C4gP5ugR5A1L5PPwPILFG",
	"OgWUC8EasZRrSECaOFGPnn+QbGRjE19GVsCWwCDSzuskjqnZT9hFR8PBzq4sy0chopSIKNEQo1uqU49o",
	"sfoEkcbbbe2SMcj6TOLP2aQAZ48NY6FAGhuH26uV+603XnUajEJtCinKbvfWAlvmPJbZ9wNHFZJN8ezl",
	"CzUpVUq5blkyhpAVkfABNGH3A2WVpd4ojlsaU0VWDE6NqDWNiIa/Qbony74v7X56tKbA4n21WQnBgPCx",
	"5OY7hezzO3XMudBWD/WIZCANl30NadLj8zv1u02qx2flg3XISHQcxxKUJ0UzEiHiFh+OHSmEPoMbGsFv",
	"tOwPulJe/bTK0tlll+y1Y23EfcQJ1WmxmkUiCzMD77dvqAgN2O2/N8ZbRAsZkpyqkmJGRXhzRFiekqOP",
	"2Gd4IT1p0srRfS0d5q5NWZpwogv51P2P6xUs52/Qgzi+Pf3Hqk69weU4xH6FLAm6adcBWfGc0m8o4tqQ",
	"KIgKSfVmaUpk2aUIwU6IotFxodO6F7X1w7xtJKVa5+58oHwthiqfSPEZZAxrdHxxjii3sf8zB27+vp3N",
	"kcohakpggDXVzDBe3pIkAYlqBjjA5gR0bI9m89nchE/kwElO8QK/ta8CnBOdWhtCCfGaqvRNLsXXTRgX",
	"WW5eJ6CHal6CLiRXaGWlIXN0Sk4Yik0PZ6VIq+B5jBf4zHAynnVut8J+ns898bIYb+Jjq86aFMxqEAmu",
	"gdtHkuesdEH4SbmjoDkW/y9hjRf4f2FzPQjLu0Ho2lobgF4KcviaQ2RyDkqaJtJ4cTWI8ZWJoDQn5HWA",
	"VZFlRG6mPGN49txsuJYQUh5Hn0ogGhQiiMMtqtqNrn8dzYVbki7hT0S8eTKntXtmj+uMUkgLU7NxO4G0",
	"LGA7iPvRE6tVYWVEr5cCJvPCNJd9PHUBYOM/hqLwzvzQeOtgxEB7irR7b/hZ96w26PxsgKhLyMRNhaic",
	"SJKBtt30VZ/d+VmvE6buaqZTHGDXQmOn1QAa7U62X4evdykX1gBnT/wSwtsP7ZkvFNvAX3ET0CXhIFrv",
	"QT+/UP3I8F0g0IrqZFaHqrnT3nsoE8bKdlFVHYRh8ZH7kHPMWHVXfpn4oRoyNRXH3hV2W/djREqy8QX4",
	"hfUiPnBN4MGYtEvTUXqivdPfgSyrK8p3g9HTtz7drzjjOHHtj/lpWfbftUJ9fB8knn2w3L1shnfuYef+",
	"qPTYfR3SvohvwFKK96K/0nMv/AffrVz/MnqRO4jerAODse6sLrX3o+Y9aAeZk41d3Rs2a9BRehComf+o",
	"fQ86y3t4nK5+NOGdb33+I39JE8u9/Umui11DcdpaPaBDfjAt9sSxdoxJQ+PUHc73+bfQ8IBvQ7WVqPka",
	"PILwQtkjvXo0SE9At4fFE7do1Bofe6/Thu1FQ7MH3JH9jjOKeafv87ljt8fvLx1V3k+yvqB7YGVnBJvO",
	"fMNfK+00YGNKcT1feLUWEmlQGgnONq8HmPoLlHbb6snGN/pWO5j8PN87y2DG8/KPbi/+lt4xlIPgo0Bn",
	"agsyyKNcS4IiVigNEpEoAqWqc2ooeQjPH9A8CGhOI84CuPyKeHXnhtF2JqkWYbiqRocz5YaJMypCklO8",
	"vd7+GwAA//8mOKqqbCcAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
